package edu.prlab.tyler.iotgateway.cloud.controllers;

import edu.prlab.tyler.iotgateway.cloud.pojo.privacy.PrivacyChoice;
import edu.prlab.tyler.iotgateway.cloud.services.PrivacyChoiceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

@RestController
public class GatewayController {
    private PrivacyChoiceService service;

    @Autowired
    public GatewayController(PrivacyChoiceService service) {
        this.service = service;
    }

    //表達隱私偏好
    @PostMapping("/choice")
    public ResponseEntity<PrivacyChoice> setPrivacyChoice(@RequestBody PrivacyChoice privacyChoice) {
        return service.add(privacyChoice)
                .map(ResponseEntity::ok)
                .orElseGet(() -> ResponseEntity.noContent().build());
    }

    //取得所有隱私偏好紀錄
    @GetMapping("/choice")
    public ResponseEntity<Iterable<PrivacyChoice>> readPrivacyChoice() {
        return Optional.of(service.readll())
                .map(ResponseEntity::ok)
                .orElseGet(() -> ResponseEntity.noContent().build());
    }

    //透過裝置取得所有隱私偏好
    @GetMapping("/choice/{udn}")
    public ResponseEntity<Iterable<PrivacyChoice>> readPrivacyChoiceByDevice(@PathVariable String udn) {
        return Optional.ofNullable(service.readPrivacyChoiceByDevice(udn))
                .map(ResponseEntity::ok)
                .orElseGet(() -> ResponseEntity.noContent().build());
    }

}